/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.wahlausschuss.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigung;
import de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungUK;

public abstract class AbstractWahlausschussEntschaedigungDAO extends de.ivu.elect.jee.entity.AbstractDAO<WahlausschussEntschaedigung,
        de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungPK
    , WahlausschussEntschaedigungUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractWahlausschussEntschaedigungDAO.class);

  public AbstractWahlausschussEntschaedigungDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public WahlausschussEntschaedigung findByPrimaryKey(
        de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected WahlausschussEntschaedigung findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(WahlausschussEntschaedigung.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: WahlAndRolleNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM WahlausschussEntschaedigung o WHERE o.wahl = ?1 AND o.wahlausschussrolle = ?2<br>
      * SQL: <br>
      */
     public WahlausschussEntschaedigung findByWahlAndRolle( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle rolle) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle rolleCheckedAndAttached =  checkAndAttach(rolle, de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle.class, "rolle"); ;
		  
                              return
                    (WahlausschussEntschaedigung)
                              getEntityManager().
                                createNamedQuery("WAHLAUSSCHUSS_ENTSCHAEDIGUNG.WahlAndRolle")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, rolleCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("WahlausschussEntschaedigung, findByWahlAndRolle - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", rolle:'"+rolle+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlAndRolle(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM WahlausschussEntschaedigung o WHERE o.wahl = ?1<br>
      * SQL: <br>
      */
     public java.util.List<WahlausschussEntschaedigung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("WAHLAUSSCHUSS_ENTSCHAEDIGUNG.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("WahlausschussEntschaedigung, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungUK uk,
        de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigung findByUK(de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigungUK uk){

    try {
     return (de.ivu.elect.business.wahlausschuss.entity.WahlausschussEntschaedigung) getEntityManager().createNamedQuery("WAHLAUSSCHUSS_ENTSCHAEDIGUNG.UK")
                  .setParameter(1, uk
                .getWahlausschussrolle ()

              )
             .setParameter(2, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getName ()

              )
             .setParameter(3, uk
                .getWahlUK ()

                .getWahlartUK ()

                .getMandantUK ()

                .getNummer ()

              )
             .setParameter(4, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getNummer ()

              )
             .setParameter(5, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getWahldatum ()

              )
             .setParameter(6, uk
                .getWahlUK ()

                .getWahlterminUK ()

                .getMandantUK ()

                .getNummer ()

              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("WahlausschussEntschaedigung, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}